
// #=====================================================================================================================#

// #
// # GPIB TOOLBOX FOR SCILAB
// # _______________________
// #
// # Version 0.9c
// # for Windows OS
// # Last modified on  : August 2005 21
// #
// # Last modifications :
// # ____________________
// #
// # 
// #
// # This software is provided "AS-IS" by Tibault Reveyrand.
// # http://membres.lycos.fr/treveyrand/
// # tibault.reveyrand@laposte.net
// #
// # Tibault Reveyrand shall have no obligation to maintain or
// # support this software. TIBAULT REVEYRAND MAKES NO EXPRESS OR IMPLIED
// # WARRANTY OF ANY KIND REGARDING THIS SOFTWARE.
// # TIBAULT REVEYRAND SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT,
// # SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES,
// # WHETHER BASED ON CONTRACT, TORT OR ANY OTHER LEGAL
// # THEORY, IN CONNECTION WITH OR ARISING OUT OF THE
// # FURNISHING, PERFORMANCE OR USE OF THIS SOFTWARE. 
// # 
// # This work has been supported by CNES (french space agency) and Ircom
// #
// # 
// # LICENCE
// # _______
// #
// # Windows GPIB Toolbox for Scilab
// # Copyright (C) 2004 Tibault Reveyrand
// #
// # This library is free software; you can redistribute it and/or
// # modify it under the terms of the GNU Lesser General Public
// # License as published by the Free Software Foundation; either
// # version 2.1 of the License, or (at your option) any later version.
// # 
// # This library is distributed in the hope that it will be useful,
// # but WITHOUT ANY WARRANTY; without even the implied warranty of
// # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// # Lesser General Public License for more details.
// #
// #
// # You should have received a copy of the GNU Lesser General Public
// # License along with this library; if not, write to the Free Software
// # Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
// #
// # Contact :
// # Tibault Reveyrand
// # tibault.reveyrand@laposte.net
// #
// # CNES and IRCOM, hereby disclaims all copyright interest in
// # the library `GPIB Toolbox' (library for Scilab) written
// # by Tibault Reveyrand.


// #=====================================================================================================================#

// #######################################################################################################################
// #######################################################################################################################
// ##                                                                                                                   ##
// ##                      Fonctions propres  l'intrumentation GPIB  (eq. aux Drivers_xxx.VEE)                         ##
// ##                                                                                                                   ##
// #######################################################################################################################
// #######################################################################################################################


// ====================================================== //
// Fonctions de base GPIB via la couche VISA (C)          //
// ====================================================== //

function GPIB_init()
	disp('Loading : GPIB Toolbox - v0.9c - August 21st 2005');
	fort("gpib_init","a",1,"c","out",[1,1],1,"c");
endfunction

function GPIB_close()
	fort("gpib_close","a",1,"c","out",[1,1],1,"c");
endfunction

function GPIB_timout(id,value_ms)
	fort("gpib_set_timout",id,1,"i",value_ms,2,"i","out",[1,1],2,"i");
endfunction

function GPIB_write(id,commande)
	// Rajoute un LineFeed  la fin de chaque instruction
	commande=commande+ascii(10);
	//
	n_commande=size(commande);
	n_commande=n_commande(1)*n_commande(2);
	commande=strcat(commande+ascii(0));		// Sparateur d'instruction
	// Remplacement des caractres spciaux...
	// commande=strsubst(commande,"\n",ascii(10));	// LineFeed
	// commande=strsubst(commande,"\r",ascii(13));	// Carriage Return
	// commande=strsubst(commande,"\t",ascii(9));	// Tab
	fort("GPIB_write",id,1,"i",n_commande,2,"i",commande,3,"c","out",[1,1],1,"i");
endfunction

function ASRL_write(commande)
	// Rajoute un LineFeed  la fin de chaque instruction
	commande=commande+ascii(10);
	//
	n_commande=size(commande);
	n_commande=n_commande(1)*n_commande(2);
	commande=strcat(commande+ascii(0));		// Sparateur d'instruction
	// Remplacement des caractres spciaux...
	// commande=strsubst(commande,"\n",ascii(10));	// LineFeed
	// commande=strsubst(commande,"\r",ascii(13));	// Carriage Return
	// commande=strsubst(commande,"\t",ascii(9));	// Tab
	fort("asrl_write",n_commande,1,"i",commande,2,"c","out",[1,1],1,"i");
endfunction


function GPIB_write_sub(id,id2,commande)
	// Rajoute un EOL  la fin de chaque instruction
	commande=commande+ascii(13)+ascii(10);
	//
	n_commande=size(commande);
	n_commande=n_commande(1)*n_commande(2);
	commande=strcat(commande+ascii(0));		// Sparateur d'instruction
	// Remplacement des caractres spciaux...
	// commande=strsubst(commande,"\n",ascii(10));	// LineFeed
	// commande=strsubst(commande,"\r",ascii(13));	// Carriage Return
	// commande=strsubst(commande,"\t",ascii(9));	// Tab
	fort("GPIB_write_sub",id,1,"i",id2,2,"i",n_commande,3,"i",commande,4,"c","out",[1,1],1,"i");
endfunction


function mat=GPIB_read(id,n_commande,buffer_size)
	buffer(1:buffer_size)=ascii(0);
	buffer=strcat(buffer);
	mat=fort("GPIB_read",id,1,"i",n_commande,2,"i",buffer_size,3,"i",buffer,4,"c","out",[length(buffer),1],4,"c");
	mat=tokens(mat,[ascii(0),ascii(10),ascii(13)]);
endfunction


function mat=ASRL_read(n_commande,buffer_size)
	buffer(1:buffer_size)=ascii(0);
	buffer=strcat(buffer);
	mat=fort("asrl_read",n_commande,1,"i",buffer_size,2,"i",buffer,3,"c","out",[length(buffer),1],3,"c");
	mat=tokens(mat,[ascii(0),ascii(10),ascii(13)]);
endfunction


function mat=GPIB_read_sub(id,id2,n_commande,buffer_size)
	buffer(1:buffer_size)=ascii(0);
	buffer=strcat(buffer);
	mat=fort("GPIB_read_sub",id,1,"i",id2,2,"i",n_commande,3,"i",buffer_size,4,"i",buffer,5,"c","out",[length(buffer),1],5,"c");
	mat=tokens(mat,[ascii(0),ascii(10),ascii(13)]);
endfunction


// ====================================================== //
// Fonctions de sauvegarde des signaux ds les AWG (C)     //
// ====================================================== //

function GPIB_AWG2021_save_signal(id,data,name)
	taille=length(data);	// Nombre de points
	fort("AWG2021_save_signal",id,1,"i",taille,2,"i",data,3,"d",name,4,"c","out",[1,1],1,"i");
endfunction

function GPIB_AWG520_save_signal(id,data,clock,name)
	taille=length(data);	// Nombre de points
	fort("AWG520_save_signal",id,1,"i",taille,2,"i",data,3,"d",name,4,"c",clock,5,"d","out",[1,1],1,"i");
endfunction


// ====================================================== //
// Fonctions standard pour Source RF ds TS4               //
// ====================================================== //

// Source HP8672A type 7 -> Range=0dBm / type 8 -> Range=10 dBm
function commande=GPIB_HP8672(ordre,param)					// HP8672A : Tres chiant !!
	if (ordre=="set_source_freq") then,
		frequency==param
		if (frequency<6.2e9) then,
			ifreq=round(frequency*1.0e-3);
			if (ifreq==0) then, 
				ifreq=1;
			end;
		elseif (frequency<12.4e9) then,
			ifreq=2*round(frequency/2.0e3);
		else
 			ifreq=3*round(frequency/3.0e3);
		end;
		tfreq=ifreq;
		cmd='W'
		while(tfreq>=10)
			cmd=ascii(ascii(cmd)-1);
			tfreq=tfreq/10;
		end;
  		commande=(cmd+string(ifreq)+'Z8');
	end;

	if (ordre=="set_source_power") then,
		power=param;
		power=((power<=0)*power-(power+99)*(power<=-100));
		commande=["K"+string(int(abs(power)/10)) ; "L"+string(abs(power)-10*int(abs(power)/10))];
		
	end;

endfunction


function GPIB_set_source_freq(id,typ,frequency)
	commande=[ 	"FR"+string(frequency)+"HZ";			// HP (typ=1)
			"CF1"+string(frequency/(10^6))+"MH";		// Wiltron (typ=2)
			"FREQ:CW "+string(frequency)+"HZ";		// Anritsu (typ=3)
			"CW"+string(frequency)+"HZ";			// HP8350A HP8340A (typ=4)
			"FREQ:CW "+string(frequency)+"HZ";		// HP8375A HP83572A (typ=5)
			":SOUR:FREQ "+string(frequency);		// IFR3414 (typ=6)
			GPIB_HP8672("set_source_freq",frequency);	// HP8672A (typ=7)
			GPIB_HP8672("set_source_freq",frequency);	// HP8672A (typ=7)
			" "	 ];	

	GPIB_write(id,commande(typ));
endfunction
 

function GPIB_set_source_power(id,typ,power)
	commande=list( 	"AP "+string(power)+" DM",...
			"L1"+string(power)+"DM",...
			"POWER:LEVEL "+string(power)+"dBm",...
			"PL"+string(power)+"DM",...
			"POW "+string(power)+"DBM",...
			[":UNIT:POW DBM"; ":POW "+string(power)],...
			GPIB_HP8672("set_source_power",power),...
			GPIB_HP8672("set_source_power",power),...
			" " );
	GPIB_write(id,commande(typ));
endfunction



function GPIB_set_source_output(id,typ,output)				// Output : On=1 ; Off=2
	commande=[	"R3"		,	"R2";
			"RF1"		,	"RF0";
			"OUTP:STATE ON"	,	"OUTP:STATE OFF";
			"RF1"		,	"RF0";
			"POW:STAT ON"	,	"POW:STAT OFF";
			"OUTPut:POWer:STATe ON","OUTPut:POWer:STATe OFF";
			"O1"		,	"O0";
			"O3"		,	"O2"	];
	GPIB_write(id,commande(typ,output));
endfunction




// ====================================================== //
// Fonctions standard pour Source de polar                //
// ====================================================== //

// 2eme version : multi_channel
// ----------------------------

	// Unit
	// 1 	: 	Volt
	// 2	:	Current

	// Type de l'Alim DC
	// 1	:	Agilent 1 Canal (Ex: HP 3455A)
	// 2	: 	Agilent x canaux (Ex: GW PPT-1830)
	// 3	: 	HP (Ex: HP 603x)
	// 4	:	Agilent  sous adresse GPIB (Ex : Agilent 66000A)
	// 5	: 	Multimetre vompatible GDM 8055 (Lecture seulement)
	// 6 	:	Multimetre Systron Donner 7344A (Lecture Seulement) || NE MARCHE PAS
	// 


function GPIB_set_bias_output(varargin)
	// Ex : GPIB_set_bias_output(id,typ,output[,chan])
	if size(varargin)<3 then disp("Use : GPIB_set_bias_output(id,typ,output[,channels]);"); abort; end;
	id=varargin(1);
	typ=varargin(2);
	output=varargin(3);
	GPIB_cmd=[ 	"OUTP ON"	,	"OUTP OFF"      ;
			" "		,	" "		];	
	select typ,
		case 1 then
			GPIB_write(id,GPIB_cmd(1,output));
		case 2 then
			if size(varargin)==3 then channel=1; else channel=varargin(4); end;
			for ch=channel,
				GPIB_write(id,"CHAN "+string(ch));
				GPIB_pause(2);
				GPIB_write(id,GPIB_cmd(1,output));
			end;
		case 3 then
			GPIB_write(id,GPIB_cmd(1,output));
		case 4 then
			if size(varargin)==3 then channel=0; else channel=varargin(4); end;
			for ch=channel,
				GPIB_write_sub(id,ch,GPIB_cmd(1,output));
			end;
	end;
endfunction



function value=GPIB_get_bias_output(varargin)
	// Ex : GPIB_get_bias_output(id,typ,output[,chan])
	if size(varargin)<2 then disp("Use : GPIB_set_bias_output(id,typ,output[,channels]);"); abort; end;
	id=varargin(1);
	typ=varargin(2);
	GPIB_cmd=[ 	"OUTP?"	;
			" "	];	
	value=[];
	select typ,
		case 1 then
			GPIB_write(id,GPIB_cmd(1));
			value=evstr(GPIB_read(id,1,30));
		case 2 then
			if size(varargin)==2 then channel=1; else channel=varargin(3); end;
			for ch=channel,
				GPIB_write(id,"CHAN "+string(ch));
				GPIB_pause(2);
				GPIB_write(id,GPIB_cmd(1));
				value=[value , evstr(GPIB_read(id,1,30))];
			end;
		case 3 then
			GPIB_write(id,GPIB_cmd(1));

		// SEUL CAS VERIFIE : AGILENT 66000A
		case 4 then
			if size(varargin)==2 then channel=0; else channel=varargin(3); end;
			for ch=channel,
				GPIB_write_sub(id,ch,GPIB_cmd(1));
				value=[value , evstr(GPIB_read_sub(id,ch,1,30))];
			end;				// Format de la source : 0=OFF 1=ON
			value(find(value<1))=2;		// Format du soft : 1=ON 2=OFF 
	end;
endfunction


function value=GPIB_get_bias(varargin)
	// Ex : GPIB_get_bias(id,typ,unit[,chan])
	if size(varargin)<3 then disp("Use : GPIB_get_bias(id,typ,unit[,channels]);"); abort; end;
	id=varargin(1);
	typ=varargin(2);
	unit=varargin(3);
	GPIB_cmd=[	"MEAS:VOLT?"	,	"MEAS:CURR?"	;		
			"VOUT?"		,	"IOUT?"		;
			" "		,	" "		];
	value=[];
	select typ,
		case 1 then
			GPIB_write(id,GPIB_cmd(1,unit));
			value=GPIB_read(id,1,30);
		
		case 2 then
			if size(varargin)==3 then channel=1; else channel=varargin(4); end;
			for ch=channel,
				GPIB_write(id,"CHAN "+string(ch));
				GPIB_pause(2);
				GPIB_write(id,GPIB_cmd(1,unit));
				value=[value , evstr(GPIB_read(id,1,30))];
			end;
		
		case 3 then
			GPIB_write(id,GPIB_cmd(2,unit));
			value=GPIB_read(id,1,30);
			kdf=tokenpos(value);
			value=part(value,kdf(2,1):kdf(2,2));
			value=evstr(value);
		
		case 4 then
			if size(varargin)==3 then channel=0; else channel=varargin(4); end;
			for ch=channel,
				GPIB_write_sub(id,ch,GPIB_cmd(1,unit));
				value=[value , evstr(GPIB_read_sub(id,ch,1,30))];
			end;
		
		case 5 then
			rep=GPIB_read(id,1,30);
			value=evstr(part(rep,[5:length(rep)]));
		
		case 6 then
			GPIB_write(id,"b9");
			GPIB_pause(1);
			value=evstr(GPIB_read(id,1,30));	
		
		
		
			
	end;
endfunction



function GPIB_set_bias(varargin)
	// Ex : GPIB_set_bias(id,typ,unit,value[,chan])
	if size(varargin)<4 then disp("Use : GPIB_set_bias(id,typ,unit,value[,channels]);"); abort; end;
	id=varargin(1);
	typ=varargin(2);
	unit=varargin(3);
	value=varargin(4);
	GPIB_cmd=[	"VOLT "	,	"CURR "	;		
			" "		,	" "		];
	select typ,
		case 1 then
			GPIB_write(id,GPIB_cmd(1,unit)+string(value(1)));
		case 2 then
			if size(varargin)==4 then channel=1; value=value(1); else channel=varargin(4); end;
			if (length(value)~=length(channel)) then disp('The number of values is not equal to the number of channels'); abort; end;
			for ch=channel,
				GPIB_write(id,"CHAN "+string(ch));
				GPIB_pause(2);
				GPIB_write(id,GPIB_cmd(1,unit)+string(value(find(channel==ch))));
			end;
		case 3 then
			GPIB_write(id,GPIB_cmd(1,unit)+string(value(1)));
		case 4 then
			if size(varargin)==4 then channel=0; value=value(1); else channel=varargin(5); end;
			if (length(value)~=length(channel)) then disp('The number of values is not equal to the number of channels'); abort; end;
			for ch=channel,
				GPIB_write_sub(id,ch,GPIB_cmd(1,unit)+string(value(find(channel==ch))));
			end;
	end;
endfunction



// ====================================================== //
// POWERMETER FUNCTIONS                                   //
// ====================================================== //

// New : 24 Aout 2005
// Language : 
//		1 : HP 438A 
//		2 : ANRITSU ML 2438A
//		3 : ANRITSU ML 2488A


function power=GPIB_get_power(id,typ,ch)

	commande=list(	list(["AP LG"],["BP LG"]),...
			list("O 1"	,	"O 2"	),...
			list(["CHUNIT 1,DBM";"CWO 1"]	,	["CHUNIT 2,DBM";"CWO 2"]	),...
			list( [] , [] ));
	GPIB_write(id,commande(typ)(ch));


//	commande=[	"AP LG"	,	"BP LG";
//			"O 1"	,	"O 2"	;
//			" "		,	" "		];
//	GPIB_write(id,commande(typ,ch));
	power=evstr(GPIB_read(id,1,30));
endfunction



function GPIB_set_power_message(id,typ,mon_texte)
	c=list (list(	" ",...
			"TEXTS OFF"),...
		list(	" ",...
			["TEXT "+part(string(mon_texte),[1:min(length(mon_texte),20)]);"TEXTS ON"]));  
	GPIB_write(id,c((length(mon_texte)>0)+1)(typ));
endfunction

// Paramtres d'entre : id,typ,ch,frequence [,table,ordre]
// Type 1 : Wattmtre HP. Cal Factor donne par une table  prciser manuellement
// Type 2 : Wattmetre Anritsu. Cal Factor stoke en EPROM
//
// Test :
// CalFactor=[	0.05 	, 	95 ;
//		2	,	95.5;
//		3	,	94.8;
//		4	,	94.2;
//		5	,	94.5;
//		6	,	94.8;
//		7	,	94.8;
//		8	,	94.8;
//		9	,	94.2;
//		10	,	94;
//		11	,	94;
//		12	,	93.5;
//		13	,	94;
//		14	,	92.8;
//		15	,	92;
//		16	,	92.8;
//		17	,	94.4;
//		18	,	99.4];
// CalFactor(:,1)=CalFactor(:,1)*10^9;
// f=(linspace(1,18,201).')*10^9; 
// plot2d(CalFactor(:,1),CalFactor(:,2));
// plot2d(f,GPIB_powermeter_calfactor(f,CalFactor,1));


// Mettre la frequence en GHz sinon probleme dans l'algo de regression (?!?)
// Attention, mthode Instable. Prendre generalerment ordre=5

function CF=GPIB_power_CF(frequency,CalFactor,ordre)
	// Regression polynnomiale d'ordre ORDRE
	x=CalFactor(:,1)./10^9;
	y=CalFactor(:,2);
	[s1,s2]=size(x);
	C=pinv(((ones(ordre+1,1)*x.').').^(ones(s1,s2)*[0:ordre]))*y;

	// Calcul du CalFactor pour la frequence FREQUENCY
	f=frequency./10^9;
	[s1,s2]=size(f);
	CF=(((ones(ordre+1,1)*f.').').^(ones(s1,s2)*[0:ordre]))*C;
//
endfunction

function GPIB_set_power_freq(varargin)


	// Valeurs par defaut
	CalFactor=[	0.0 	, 	100 ;
			20	,	100];
	CalFactor(:,1)=CalFactor(:,1)*10^9;
	ordre=0;

	if size(varargin)<4 then disp("Use : GPIB_set_bias(id,typ,unit,value[,channels]);"); abort; end;
	id=varargin(1);
	typ=varargin(2);
	ch=varargin(3);
	frequence=varargin(4);
	if size(varargin)>4 then,
		CalFactor=varargin(5);
		ordre=varargin(6);
	end;

	CF=GPIB_power_CF(frequence,CalFactor,ordre);
	commande=list(	list(["AP";"KB"+string(CF)+"EN"],["BP";"KB"+string(CF)+"EN"]),...
			list("CFFRQ A,"+string(frequence)	,	"CFFRQ B,"+string(frequence)	),...
			list(["CHMODE 1,CW";"SNCFSRC A,FREQ";"SNCFRQ A,"+string(frequence)]	,	["CHMODE 2,CW";"SNCFSRC B,FREQ";"SNCFRQ B,"+string(frequence)]	),...
			list( [] , [] ));
	GPIB_write(id,commande(typ)(ch));
	// power=evstr(GPIB_read(id,1,30));
endfunction





// ====================================================== //
// Fonctions standard pour les step ATT                   //
// ====================================================== //


function GPIB_set_att(id,value)

  if (value>=0) & (value<=81) then,
    	if (value<=79) then, dizaine=int(value/10); else dizaine=7; end;
	unite=int(value-dizaine*10);
	commande_dizaine=[	"B1234";	// 0  -> i=1
			  	"A1B234";	// 10 -> i=2
			  	"A2B134";	// 20 -> i=3
				"A12B34";	// 30 -> i=4
				"A3B124";	// 40 -> i=5
				"A13B24";	// 50 -> i=6
				"A23B14";	// 60 -> i=7
				"A123B4"  ];	// 70 -> i=8

	commande_unite=[	"B5678";	// 0 -> i=1
				"A5B678";	// 1 -> i=2
				"A6B578";	// 2 -> i=3
				"A56B78";	// 3 -> i=4
				"A7B568";	// 4 -> i=5
				"A57B68";	// 5 -> i=6
				"A67B58";	// 6 -> i=7
				"A576B8";	// 7 -> i=8
				"A78B56";	// 8 -> i=9
				"A578B6";	// 9 -> i=10
			
				"A678B5";	// Att=10 non utilis sauf pour 80 et 81
				"A5678" ];	// Att=11 non utilis sauf pour 80 et 81
   	cmd=commande_dizaine(dizaine+1)+commande_unite(unite+1);
	GPIB_write(id,cmd);
   end;

endfunction

// ====================================================== //
// Fonctions standard pour AWG dans TS4                   //
// ====================================================== //


function GPIB_set_awg_envelope(id,typ,data,clock)
	data=TS_normalize(data);
	cmd=[	"GPIB_AWG520_save_signal(id,real(data),clock,""real.wfm"");"	,	"GPIB_AWG520_save_signal(id,imag(data),clock,""imag.wfm"");" ;
		"GPIB_AWG2021_save_signal(id,real(data),""real.wfm"");"		,	"GPIB_AWG2021_save_signal(id,imag(data),""imag.wfm"");" 	];
	execstr(cmd(typ,:));

	cmd=[	":SOUR1:FUNC:USER ""real.wfm"",""MAIN"""	,	":SOUR2:FUNC:USER ""imag.wfm"",""MAIN"""	;
		":CH1:WAV ""real.wfm"""				,	":CH2:WAV ""imag.wfm"""				];

	GPIB_write(id,cmd(typ,:));
	if (typ==2) then GPIB_write(id,":CLOC:FREQ "+string(clock/(10^6))+"MHZ"); end;
endfunction



function GPIB_set_awg_amplitude(id,typ,amplitude)				// ex : amplitude=[0.1 0.2]
	commande=[	"SOUR1:VOLT:LEV:IMM:AMPL "+string(amplitude(1))+"V"	,	"SOUR2:VOLT:LEV:IMM:AMPL "+string(amplitude(2))+"V";		// typ=1 => AWG 520
			":CH1:AMPL "+string(amplitude(1))+"V"			,	":CH2:AMPL "+string(amplitude(2))+"V"			];	// typ=2 => AWG 2021

	GPIB_write(id,commande(typ,:));
endfunction


function GPIB_set_awg_run(id,typ,cmd)					// commande=1 -> RUN commande=2 -> STOP
	commande=[	"AWGC:RUN" , "AWGC:STOP" ; 			// typ=1 => AWG 520
			" " , " "	] ;				// typ=2 => AWG 2021 : commande inexistante
	GPIB_write(id,commande(typ,cmd));
endfunction



function GPIB_set_awg_output(id,typ,output)				// ex: output=[1 2] On=1 ; Off=2 => 1er ch ON / 2eme ch OFF 
	commande=hypermat([2 2 2],[	"OUTP1:STAT ON"	; 	"OUTP1:STAT OFF" ;	// typ=1 AWG 520
					"OUTP2:STAT ON"	; 	"OUTP2:STAT OFF" ;

					"OUTP:CH1:STAT ON"; 	"OUTP:CH1:STAT OFF" ;	// typ=2 AWG 2021
					"OUTP:CH2:STAT ON"; 	"OUTP:CH2:STAT OFF" 	]);
	
	GPIB_write(id,[commande(output(1),1,typ);commande(output(2),2,typ)]);
endfunction



// ====================================================== //
// Fonctions standard pour TDS dans TS4                   //
// ====================================================== //

// Attention, il faut parfois prvoir un time-out suprieur aux 2 secondes par defaut pour chacune
// des fonctions ici prsente !!!  (surtout l'autoscale !!!)
// Ex : ch = [ 3 1] ==> Env = Ch3 + %i*Ch1

function GPIB_set_tds_autoscale(id,ch)

    GPIB_write(id,	[	":ACQ:MOD PEAK";						// Mode PEAK a essayer peut etre aussi...
				":ACQ:STOPA RUNST";
				":ACQ:STATE RUN"					]);
    for (i=1:length(ch)),

	GPIB_write(id,	[	":CH"+string(ch(i))+":POS 0";
				":CH"+string(ch(i))+":OFFSET 0";
				":SELECT:CH"+string(ch(i))+" ON";
				":MEASU:GAT OFF";
				":MEASU:IMM:SOURCE CH"+string(ch(i))			]);

	_exit=%F;
	while (_exit==%F),
	

	GPIB_write(id,	[	":MEASU:IMM:TYP MAX";
				":MEASU:IMM:VAL?" 					]);
				v_max=evstr(GPIB_read(id,1,30));
	GPIB_write(id,	[	"*ESR?"							]);
				erreur1=evstr(GPIB_read(id,1,30));
	GPIB_write(id,	[	"EVENT?"						]);
				event1=evstr(GPIB_read(id,1,30));	
	GPIB_write(id,	[	":MEASU:IMM:TYP MINI";
				":MEASU:IMM:VAL?"  					]);
				v_min=evstr(GPIB_read(id,1,30));
	GPIB_write(id,	[	"*ESR?"							]);
				erreur2=evstr(GPIB_read(id,1,30));
	GPIB_write(id,	[	"EVENT?"						]);
				event2=evstr(GPIB_read(id,1,30));	

				if (((547<=event1) & (event1<550)) | ((547<=event2) & (event2<550))) then
		GPIB_write(id,	[	":CH"+string(ch(i))+":SCA?"					]);
					scale=evstr(GPIB_read(id,1,30))
		GPIB_write(id,	[	":CH"+string(ch(i))+":SCA "+string(scale*2)			]);
				else
					_exit=%T;
				end;
	end;

	GPIB_write(id,	[	":CH"+string(ch(i))+":SCA "+string((v_max-v_min)/9);
				":CH"+string(ch(i))+":OFFSET "+string( v_min+(v_max-v_min)/2 )	]);
   end;
endfunction


function GPIB_pause(delay_s)
	my_delay=0;
	u=timer();
	while(my_delay<delay_s) then,
		my_delay=my_delay+timer();
	end;
endfunction



function GPIB_set_tds_acquisition(id,average)


	average=abs(int(average));

	if (average>1) then,
		GPIB_write(id, 	[	":ACQ:MOD AVE";
					 // ":ACQ:STOPA RUNST";
					":ACQ:STOPA SEQ";
					":ACQUIRE:NUMAVG "+string(average);
					":ACQ:STATE RUN"				]);
		
	else

			GPIB_write(id, [	":ACQ:MOD SAM";
						// ":ACQ:STOPA RUNST";
						":ACQ:STOPA SEQ";
						":ACQ:STATE RUN"]);
	
	end;
	busy=1;
		while (busy~=0) then
			GPIB_pause(3);
			GPIB_write(id,"BUSY?");
			busy=evstr(GPIB_read(id,1,30));
		end;
	
endfunction




function raw_data=GPIB_get_tds_envelope(id,ch,start,stop)

	// hi_res : %T : Transfert en 16 bits / %F : Transfert en 8 bits
	hi_res=%T;
	// ch doit tre un vecteur CROISSANT
	ch=sort(ch); ch=ch($:-1:1);

	source=strcat("CH"+string(ch)+",");
	source=part(source,linspace(1,length(source)-1,length(source)-1));
	scale=zeros(4,4); offset=zeros(4,1); position=zeros(4,1);
	for i=1:length(ch),
		GPIB_write(id,["CH"+string(ch(i))+":SCA?"]);
		scale(ch(i),ch(i))=evstr(GPIB_read(id,1,50));
		// Lecture des offsets et positions...
		GPIB_write(id,["CH"+string(ch(i))+":OFFSET?"]);
		offset(ch(i))=evstr(GPIB_read(id,1,50));
		GPIB_write(id,["CH"+string(ch(i))+":POSITION?"]);
		position(ch(i))=evstr(GPIB_read(id,1,50));
	end;
		commande=[	"*CLS";
			"DAT:ENC RIB";
			"DATA:WID "+string(1+1*hi_res);
			"DATA:SOURCE "+source;
			"DAT:STAR "+string(start);
			"DAT:STOP "+string(stop);
			"CURV?"	];

	data=linspace(0,0,(stop-start+1));
	taille=length(data);
	raw_data=zeros(taille,4);
	GPIB_write(id,commande);
	for i=1:length(ch),
		if (hi_res==%F) then raw_data(:,ch(i))=fort("GPIB_read_block_byte",id,1,"i",taille,2,"i",data,3,"d","out",[taille,1],3,"d");
		else raw_data(:,ch(i))=fort("GPIB_read_block_short",id,1,"i",taille,2,"i",data,3,"d","out",[taille,1],3,"d");
		end;
	end;
	raw_data=(raw_data/(2^(7+8*(hi_res))))*5*scale;

	// Lecture du DC ajuste par Offset et Position
	for i=1:length(ch), raw_data(:,ch(i))=raw_data(:,ch(i))+offset(ch(i))-position(ch(i))*scale(ch(i),ch(i)); end;
endfunction




